<?php
ini_set('display_errors', 1);
error_reporting(E_ALL);
define('TIMESTART', timeMeasure());
define('ROOT_DIR', dirname(__FILE__));
header('Content-Type: text/html; charset=utf-8');
mb_internal_encoding('UTF-8');

#SETTINGS
$salt = 'C9BkFjayNh2lyhGV06uorKR0MsWNAJ';

$admin = 'lrosillznlklvzqkrtaj'; #Для доступа - подставить слово из этой переменной в гет-запрос, тогда скрипт создаст куку (notepad.php?secret)

$sitesArray = array(
	'get-tune.net' => array('AdvertMoney', 'Ruster', 'JS программист',),
	'mp3.cc' => array('AdvertMoney', 'Ruster', 'JS программист',),
	'sexxx.cc' => array('AdvertMoney', 'Ruster', 'JS программист',),
	'lol24.ee' => array('AdvertMoney', 'Ruster', 'JS программист',),
	'chef.tm' => array('AdvertMoney', 'Ruster', 'JS программист',),
	'eee.fm' => array('AdvertMoney', 'Ruster', 'JS программист',),
	'videobox.tv' => array('AdvertMoney', 'Ruster',),
	
	'xmusic.me' => array('AdvertMoney', 'Ruster', 'JS программист',),
	);

$staticFolder = 'public';
$dynamicFolder = 'secure';

$dateTemplate = date('Ymdhisu');

#WORKER
$successArray = $errorsArray = array();
$viewDynamic = '';
$documentUri = isset($_SERVER['DOCUMENT_URI'])?$_SERVER['DOCUMENT_URI']:(isset($_SERVER['SCRIPT_NAME'])?$_SERVER['SCRIPT_NAME']:'');

$sitesHashArray = getNewSiteArray($sitesArray);

if(!is_dir($staticFolder) AND !is_writable($staticFolder)){
	$errorsArray[] = 'Директория для статических файлов не существует или не доступна для записи';
}

if(!is_dir($dynamicFolder) AND !is_writable($dynamicFolder)){
	$errorsArray[] = 'Директория для динамических файлов не существует или не доступна для записи';
}

if(isset($_GET[$admin])){
	setcookie($admin, true,  time() + (60 * 60 * 24 * 365 * 5), '/', $_SERVER['HTTP_HOST'], false, true);
	header('Location: '.$_SERVER['SCRIPT_NAME']);
	exit();
}

$reqAction = isset($_REQUEST['action'])?$_REQUEST['action']:'';
$postHash = isset($_POST['hash'])?$_POST['hash']:'';
$getSiteHash = isset($_GET['site_hash'])?$_GET['site_hash']:'';
$getNotepadHash = isset($_GET['notepad_hash'])?$_GET['notepad_hash']:'';

if (!$errorsArray) {
	switch ($reqAction) {
		case 'get_dynamic':
			if ($getSiteHash AND $getNotepadHash AND isset($sitesHashArray[$getSiteHash]['notepad_array'][$getNotepadHash])) {
				$filenameFull = ROOT_DIR.'/'.$dynamicFolder.'/'.getFilename($getSiteHash, $getNotepadHash, $salt);
				$viewDynamic = file_exists($filenameFull)?file_get_contents($filenameFull):'';

				#Запрещаем кешировать
				header('Expires: Mon, 26 Jul 1997 05:00:00 GMT');
				header('Last-Modified: '.gmdate('D, d M Y H:i:s').' GMT');
				header('Cache-Control: no-store, no-cache, must-revalidate');
				header('Cache-Control: post-check=0, pre-check=0', false);
				header('Pragma: no-cache');
			} else {
				$errorsArray[] = 'Проверьте корректность ссылки.';
			}
			break;

		case 'save':
			if (isset($_COOKIE[$admin])) {
				$postSiteHash = isset($_POST['site_hash'])?$_POST['site_hash']:'';
				$postActionMore = isset($_POST['action_more'])?$_POST['action_more']:'';
				$postNotepadHash = isset($_POST['notepad_hash'])?$_POST['notepad_hash']:'';
				$postNotepadContent = isset($_POST['notepad_content'])?$_POST['notepad_content']:'';
				$postNotepadContentHash = isset($_POST['notepad_content_hash'])?$_POST['notepad_content_hash']:'';
				if ($postNotepadContentHash AND $postSiteHash AND $postNotepadHash AND isset($sitesHashArray[$postSiteHash]['notepad_array'][$postNotepadHash])) {
					$fileName = getFilename($postSiteHash, $postNotepadHash, $salt);
					$filenameFull = $dynamicFolder.'/'.$fileName;
					$fileContent = file_exists($filenameFull)?file_get_contents($filenameFull):'';
					$fileContentHash = md5($fileContent);
					if ($postNotepadContentHash == $fileContentHash) {
						if (file_put_contents($dynamicFolder.'/'.$fileName, $postNotepadContent, LOCK_EX)) {
							$successArray[] = 'Изменения сохранены!';
						} else {
							$errorsArray[] = 'Что-то пошло не так ('.__LINE__.')!';
						}
						if ($postActionMore == 'dynamic') {
							$successArray[] = 'Динамический <a href="?action=get_dynamic&amp;site_hash='.$postSiteHash.'&amp;notepad_hash='.$postNotepadHash.'" target="_blank">файл</a> успешно сохранён!';
						} elseif ($postActionMore == 'static') {
							$filenameStatic = $staticFolder.'/'.$dateTemplate.'_'.$postSiteHash.'_'.$postNotepadHash.'.txt';
							if (file_put_contents($filenameStatic, chr(239).chr(187).chr(191).$postNotepadContent, LOCK_EX)) {
								$successArray[] = 'Файл <a href="'.$filenameStatic.'" target="_blank">'.$filenameStatic.'</a> успешно сохранён!';
							} else {
								$errorsArray[] = 'Что-то пошло не так ('.__LINE__.')!';
							}
						}
					} else {
						$errorsArray[] = 'Файл '.$fileName.' был кем-то изменен!';
					}

				} else {
					$errorsArray[] = 'Ошибка '.__LINE__.'.';
				}
			} else {
				$errorsArray[] = 'Какие волшебные слова Вы знаете???';
			}
			break;

		default:

			break;
	}
}

if (! isset($_COOKIE[$admin]) AND $reqAction != 'get_dynamic') {
	$errorsArray[] = 'Какие волшебные слова Вы знаете???';
}

$sitesHashArray = getNewSiteArray($sitesArray);

?><!DOCTYPE html>
<html>
<head>
	<title>Список дел</title>
	<meta charset="utf-8"/>
	<style>
		* {
			box-sizing: border-box;
		}

		body {
			margin: 0;

			line-height: 1.5;
			font-size: 16px;
			font-family: arial, sans-serif;
			background-color: #FFF;
			color: #222;
		}

		input,
		textarea,
		select {
			font-family: inherit;
			font-size: inherit;
		}

		textarea {
			width: 100%;
			height: 70vh;
			border: 2px solid #CCC;
			padding: 10px;
		}

		select {
			border: 2px solid #CCC;
			padding: 5px 10px;
		}

		#container {
			margin: 20px;
		}

		.alert{
			width: 100%;
			border: 1px solid gray;
			border-radius: 5px;
			padding: 5px;
			margin-bottom: 25px;
		}

		.alert-success{
			background-color: #DFF0D8;
			border-color: #d6e9c6;
			color: #3c763d;
		}

		.alert-danger{
			background-color: #f2dede;
			border-color: #ebccd1;
			color: #a94442;
		}
	</style>
</head>
<body>
	<div id="container">
		<!-- ALERTS -->
		<div id="errors">
			<?php if ($errorsArray) { ?>
				<div class="alert alert-danger">
					<ul>
					<?php foreach ($errorsArray as $id => $error) { ?>
						<li><?=$error?></li>
					<?php } ?>
					</ul>
				</div>
			<?php } ?>
		</div>
		<div id="success">
			<?php if ($successArray) { ?>
				<div class="alert alert-success">
					<ul>
					<?php foreach ($successArray as $id => $good_news) { ?>
						<li><?=$good_news?></li>
					<?php } ?>
					</ul>
				</div>
			<?php } ?>
		</div>
		<!-- END ALERTS -->
		<?php if ($reqAction == 'get_dynamic') { ?>
		<pre><?=htmlspecialchars($viewDynamic)?></pre>
		<?php } elseif (isset($_COOKIE[$admin]) AND $reqAction !== 'get_dynamic') { ?>
			<!-- SITE SELECT -->
			<form action="?" method="GET">
				<select name="site_hash" onchange="this.form.submit()">
					<?php foreach ($sitesHashArray as $siteHash => $data) { ?>
						<option value="<?=$siteHash?>" <?=($siteHash == $getSiteHash)?'selected="selected"':'' ?>><?=htmlspecialchars($data['name']).($data['timestamp_last_modification']?(date(' (Y.m.d H:i:s)', $data['timestamp_last_modification'])):'') ?></option>
					<?php } ?>
				</select>
				<button type="submit">выбрать</button>
			</form>
			 <!-- END SITE SELECT -->

			<hr />
			<br />

			<!-- NOTEPADS -->
			<?php
			$currentSiteArray = ($getSiteHash AND isset($sitesHashArray[$getSiteHash]))?$sitesHashArray[$getSiteHash]:reset($sitesHashArray);
			foreach ($currentSiteArray['notepad_array'] as $notepadHash => $notepadName) {
				$fileName = getFilename($currentSiteArray['hash'], $notepadHash, $salt);
				$fileDate = $fileContentHash = $fileContent = '';
				$filenameFull = $dynamicFolder.'/'.$fileName;

				if (file_exists($filenameFull)){
					$fileContent = file_get_contents($filenameFull);
					$fileDate = date('(d.m.Y h:i:s)', filemtime($filenameFull));
				}
				$fileContentHash = md5($fileContent);
				$formName = 'form_'.$notepadHash;
				?>
				<a name="<?=$formName?>"></a>
				<form action="?site_hash=<?=$currentSiteArray['hash']?>#<?=$formName?>" name="<?=$formName?>" method="post">
					<input type="hidden" name="action" value="save" />
					<input type="hidden" name="action_more" value="nothing" />
					<input type="hidden" name="site_hash" value="<?=$currentSiteArray['hash']?>" />
					<input type="hidden" name="notepad_hash" value="<?=$notepadHash?>" />
					<input type="hidden" name="notepad_content_hash" value="<?=$fileContentHash?>" />
					<b><?=htmlspecialchars($notepadName)?></b> <?=$fileDate?><br />
					<textarea name="notepad_content"><?=htmlspecialchars($fileContent)?></textarea>
					<br />
					<input onclick="document.<?=$formName?>.submit();" type="button" value="сохранить" />
					<input onclick="document.<?=$formName?>.action_more.value='dynamic'; document.<?=$formName?>.submit();" type="button" value="сохранить + ссылку на файл (динамический)" />
					<input onclick="document.<?=$formName?>.action_more.value='static'; document.<?=$formName?>.submit();" type="button" value="сохранить + создать статистический файл" />
				</form>

				<br /> <br />
			<?php } ?>
			<!-- END NOTEPADS -->
		<?php } else {

			} ?>
	</div>


</body>
</html><?php

echo PHP_EOL.'<!-- '.round(timeMeasure() - TIMESTART, 6). '. -->';

function timeMeasure() {
	list($msec, $sec)= explode(chr(32), microtime());
	return($sec + $msec);
}

function getFilename($siteHash, $notepadHash, $salt) {
	return md5($siteHash.'|'.$salt).'_'.md5($notepadHash.'|'.$salt);
}

function getNewSiteArray($sitesArray) {
	global $salt, $dynamicFolder;
	$sitesHashArray = array();
	foreach ($sitesArray as $siteName => $data) {
		if (is_array($data) AND count($data)) {
			$siteNameHash = md5(trim(mb_strtolower($siteName)));
			$notepadArray = array();
			$timestampLastModification = 0;
			foreach ($data as $notedapName) {
				$notedapNameHash = md5(trim(mb_strtolower($notedapName)));
				$notepadArray[$notedapNameHash] = $notedapName;
				$fileNameFull = $dynamicFolder.'/'.getFilename($siteNameHash, $notedapNameHash, $salt);
				$timestampLastModification = (file_exists($fileNameFull) AND filemtime($fileNameFull) >= $timestampLastModification)?filemtime($fileNameFull):$timestampLastModification;
			}
			$sitesHashArray[$siteNameHash] = array(
				'name' => $siteName,
				'hash' => $siteNameHash,
				'timestamp_last_modification' => $timestampLastModification,
				'notepad_array' => $notepadArray,
				);
		}
	}
	return $sitesHashArray;
}